select
    an.cdanimal,
    an.numero,
    (select grausangue from sp_calculagrausangue(an.cdanimal)) as raca,
    (case when (ultev.cdtiporeproducao = 1) then 'Inseminada' when (ultev.cdtiporeproducao = 2) then 'Coberta' when
        (ultev.cdtiporeproducao = 3) then 'Implantada' when (ultev.cdtiporeproducao = 7 or ultev.diagnostico = 'N')
            then 'Vazia' when (ultev.diagnostico = 'P') then 'Gestante' when (ultev.cio in (1,2)) then 'Vazia'
                else 'Vazia' end) as situacao_reprodutiva,
    (case when (ultev.diagnostico = 'P') then ultev.dtpartoprovavel else null end) as parto_provavel,
    (case when exists (select * from lactacao lac where lac.cdanimal = an.cdanimal and lac.dtfim is null) then
        'Lactao' else 'Seca' end) as situacao_produtiva,
    (select count(*) from lactacao lac where lac.cdanimal = an.cdanimal) as ordem_lactacao,
    pai.numero as numero_pai,
    pai.nomecompleto as nome_pai,
    mae.numero as numero_mae,
    mae.nomecompleto as nome_mae,
    avo.numero as numero_avo,
    avo.nomecompleto as nome_avo,
    prilac.dtinicio as inicio_pri_lactacao,
    prilac.dtfim as fim_pri_lactacao,
    (case when (prilac.dtinicio is not null) then (select producao305 from sp_producao305(prilac.cdlactacao)) else null
        end) as producao_305_pri,
    (case when (prilac.dtfim is not null) then (select producaototal from sp_calculaproducaototal(prilac.cdlactacao,
        prilac.dtfim)) else null end) as producao_total_pri,
    seglac.dtinicio as inicio_seg_lactacao,
    seglac.dtfim as fim_seg_lactacao,
    (case when (seglac.dtinicio is not null) then (select producao305 from sp_producao305(seglac.cdlactacao)) else null
        end) as producao_305_seg,
    (case when (seglac.dtfim is not null) then (select producaototal from sp_calculaproducaototal(seglac.cdlactacao,
        seglac.dtfim)) else null end) as producao_total_seg,
    terlac.dtinicio as inicio_ter_lactacao,
    terlac.dtfim as fim_ter_lactacao,
    (case when (terlac.dtinicio is not null) then (select producao305 from sp_producao305(terlac.cdlactacao)) else null
        end) as producao_305_ter,
    (case when (terlac.dtfim is not null) then (select producaototal from sp_calculaproducaototal(terlac.cdlactacao,
        terlac.dtfim)) else null end) as producao_total_ter,
    quarlac.dtinicio as inicio_quar_lactacao,
    quarlac.dtfim as fim_quar_lactacao,
    (case when (quarlac.dtinicio is not null) then (select producao305 from sp_producao305(quarlac.cdlactacao)) else null
        end) as producao_305_quar,
    (case when (quarlac.dtfim is not null) then (select producaototal from sp_calculaproducaototal(quarlac.cdlactacao,
        quarlac.dtfim)) else null end) as producao_total_quar,
    quinlac.dtinicio as inicio_quin_lactacao,
    quinlac.dtfim as fim_quin_lactacao,
    (case when (quinlac.dtinicio is not null) then (select producao305 from sp_producao305(quinlac.cdlactacao)) else null
        end) as producao_305_quin,
    (case when (quinlac.dtfim is not null) then (select producaototal from sp_calculaproducaototal(quinlac.cdlactacao,
        quinlac.dtfim)) else null end) as producao_total_quin,
    sexlac.dtinicio as inicio_sex_lactacao,
    sexlac.dtfim as fim_sex_lactacao,
    (case when (sexlac.dtinicio is not null) then (select producao305 from sp_producao305(sexlac.cdlactacao)) else null
        end) as producao_305_sex,
    (case when (sexlac.dtfim is not null) then (select producaototal from sp_calculaproducaototal(sexlac.cdlactacao,
        sexlac.dtfim)) else null end) as producao_total_sex,
    setlac.dtinicio as inicio_set_lactacao,
    setlac.dtfim as fim_set_lactacao,
    (case when (setlac.dtinicio is not null) then (select producao305 from sp_producao305(setlac.cdlactacao)) else null
        end) as producao_305_set,
    (case when (setlac.dtfim is not null) then (select producaototal from sp_calculaproducaototal(setlac.cdlactacao,
        setlac.dtfim)) else null end) as producao_total_set,
    oitlac.dtinicio as inicio_oit_lactacao,
    oitlac.dtfim as fim_oit_lactacao,
    (case when (oitlac.dtinicio is not null) then (select producao305 from sp_producao305(oitlac.cdlactacao)) else null
        end) as producao_305_oit,
    (case when (oitlac.dtfim is not null) then (select producaototal from sp_calculaproducaototal(oitlac.cdlactacao,
        oitlac.dtfim)) else null end) as producao_total_oit,
    nonlac.dtinicio as inicio_non_lactacao,
    nonlac.dtfim as fim_non_lactacao,
    (case when (nonlac.dtinicio is not null) then (select producao305 from sp_producao305(nonlac.cdlactacao)) else null
        end) as producao_305_non,
    (case when (nonlac.dtfim is not null) then (select producaototal from sp_calculaproducaototal(nonlac.cdlactacao,
        nonlac.dtfim)) else null end) as producao_total_non,
    declac.dtinicio as inicio_dec_lactacao,
    declac.dtfim as fim_dec_lactacao,
    (case when (declac.dtinicio is not null) then (select producao305 from sp_producao305(declac.cdlactacao)) else null
        end) as producao_305_dec,
    (case when (declac.dtfim is not null) then (select producaototal from sp_calculaproducaototal(declac.cdlactacao,
        declac.dtfim)) else null end) as producao_total_dec,
    decprilac.dtinicio as inicio_decpri_lactacao,
    decprilac.dtfim as fim_decpri_lactacao,
    (case when (decprilac.dtinicio is not null) then (select producao305 from sp_producao305(decprilac.cdlactacao)) else null
        end) as producao_305_decpri,
    (case when (decprilac.dtfim is not null) then (select producaototal from sp_calculaproducaototal(decprilac.cdlactacao,
        decprilac.dtfim)) else null end) as producao_total_decpri,
    decseglac.dtinicio as inicio_decseg_lactacao,
    decseglac.dtfim as fim_decseg_lactacao,
    (case when (decseglac.dtinicio is not null) then (select producao305 from sp_producao305(decseglac.cdlactacao)) else null
        end) as producao_305_decseg,
    (case when (decseglac.dtfim is not null) then (select producaototal from sp_calculaproducaototal(decseglac.cdlactacao,
        decseglac.dtfim)) else null end) as producao_total_decseg
from
    animal an
    left join reproducao ultev on ultev.cdreproducao =
        (select first 1 re.cdreproducao from reproducao re where re.cdanimal = an.cdanimal and
            ((re.cdtiporeproducao in (1,2,3,7)) or (re.diagnostico is not null) or (re.cio in (1,2))) order by
                re.data desc)
    left join animal pai on pai.cdanimal = an.cdpai
    left join animal mae on mae.cdanimal = an.cdmae
    left join animal avo on avo.cdanimal = mae.cdpai
    left join lactacao prilac on prilac.cdlactacao =
        (select first 1 re.cdlactacao from lactacao re where re.cdanimal = an.cdanimal order by re.dtinicio)
    left join lactacao seglac on seglac.cdlactacao =
        (select first 1 re.cdlactacao from lactacao re where re.cdanimal = an.cdanimal and re.dtinicio >= prilac.dtinicio and
            prilac.cdlactacao <> re.cdlactacao order by re.dtinicio)
    left join lactacao terlac on terlac.cdlactacao =
        (select first 1 re.cdlactacao from lactacao re where re.cdanimal = an.cdanimal and re.dtinicio >= seglac.dtinicio and
            seglac.cdlactacao <> re.cdlactacao order by re.dtinicio)
    left join lactacao quarlac on quarlac.cdlactacao =
        (select first 1 re.cdlactacao from lactacao re where re.cdanimal = an.cdanimal and re.dtinicio >= terlac.dtinicio and
            terlac.cdlactacao <> re.cdlactacao order by re.dtinicio)
    left join lactacao quinlac on quinlac.cdlactacao =
        (select first 1 re.cdlactacao from lactacao re where re.cdanimal = an.cdanimal and re.dtinicio >= quarlac.dtinicio and
            quarlac.cdlactacao <> re.cdlactacao order by re.dtinicio)
    left join lactacao sexlac on sexlac.cdlactacao =
        (select first 1 re.cdlactacao from lactacao re where re.cdanimal = an.cdanimal and re.dtinicio >= quinlac.dtinicio and
            quinlac.cdlactacao <> re.cdlactacao order by re.dtinicio)
    left join lactacao setlac on setlac.cdlactacao =
        (select first 1 re.cdlactacao from lactacao re where re.cdanimal = an.cdanimal and re.dtinicio >= sexlac.dtinicio and
            sexlac.cdlactacao <> re.cdlactacao order by re.dtinicio)
    left join lactacao oitlac on oitlac.cdlactacao =
        (select first 1 re.cdlactacao from lactacao re where re.cdanimal = an.cdanimal and re.dtinicio >= setlac.dtinicio and
            setlac.cdlactacao <> re.cdlactacao order by re.dtinicio)
    left join lactacao nonlac on nonlac.cdlactacao =
        (select first 1 re.cdlactacao from lactacao re where re.cdanimal = an.cdanimal and re.dtinicio >= oitlac.dtinicio and
            oitlac.cdlactacao <> re.cdlactacao order by re.dtinicio)
    left join lactacao declac on declac.cdlactacao =
        (select first 1 re.cdlactacao from lactacao re where re.cdanimal = an.cdanimal and re.dtinicio >= nonlac.dtinicio and
            nonlac.cdlactacao <> re.cdlactacao order by re.dtinicio)
    left join lactacao decprilac on decprilac.cdlactacao =
        (select first 1 re.cdlactacao from lactacao re where re.cdanimal = an.cdanimal and re.dtinicio >= declac.dtinicio and
            declac.cdlactacao <> re.cdlactacao order by re.dtinicio)
    left join lactacao decseglac on decseglac.cdlactacao =
        (select first 1 re.cdlactacao from lactacao re where re.cdanimal = an.cdanimal and re.dtinicio >= decprilac.dtinicio and
            decprilac.cdlactacao <> re.cdlactacao order by re.dtinicio)
where
    an.tipoanimal = 'A' and
    an.animalrebanho = '1' and
    an.cdcategoria = 7 and
    an.dtbaixa is null